#Campus School Project
import board, neopixel, digitalio, time
from adafruit_debouncer import Button
from audiopwmio import PWMAudioOut as AudioOut
from audiocore import WaveFile

# set up the speaker
speaker = digitalio.DigitalInOut(board.SPEAKER_ENABLE)
speaker.direction = digitalio.Direction.OUTPUT
speaker.value = True
audio = AudioOut(board.A1)

button_input = digitalio.DigitalInOut(board.A2)
button_input.switch_to_input(digitalio.Pull.UP) # Note: Pull.UP for external buttons
button_1 = Button(button_input) # NOTE: False for external buttons

button_input = digitalio.DigitalInOut(board.A3)
button_input.switch_to_input(digitalio.Pull.UP) # Note: Pull.UP for external buttons
button_2 = Button(button_input) # NOTE: False for external buttons

strip = neopixel.NeoPixel(board.A6, 40)
RED = (255, 0, 0)
YELLOW = (255, 120, 0)
BLACK = (0, 0, 0)

turn = 0
index = 0
redIds = [11, 12, 13, 14, 15, 16, 17, 18, 19, 20]
yellowIds = [9, 8, 7, 6, 5, 4, 3, 2, 1, 0]
strip.fill(BLACK)

path = "sounds/"

# play_sound function - pass in the FULL NAME of file to play
def play_sound(filename):
    with open(path + filename, "rb") as wave_file:
        wave = WaveFile(wave_file)
        audio.play(wave)
        while audio.playing:
            flash()

def flash():
    strip[0: 10] = YELLOW * 10
    strip[11: 21] = BLACK * 10
    strip[10] = RED
    strip[21: 40] = RED * 19
    time.sleep(0.4)
    strip[0: 10] = BLACK * 10
    strip[11: 21] = RED * 10
    strip[10] = YELLOW
    strip[21: 40] = YELLOW * 19
    time.sleep(0.4)

while True:
    button_1.update() # Gets current state of button
    button_2.update()
    if button_2.pressed and turn == 0:
        print("1 pressed")
        strip[redIds[index]] = RED
        turn = 1
    if button_1.pressed and turn == 1:
        print("2 pressed")
        strip[yellowIds[index]] = YELLOW
        turn = 0
        index += 1
    if index >= 10:
        time.sleep(1)
        play_sound("for-boston.wav")
        index = 0
        strip[0: 10] = YELLOW * 10
        strip[11: 21] = RED * 10
        strip[21: 40] = BLACK * 19
        time.sleep(10)
        strip.fill(BLACK)
